package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.OrderGoodsService;
import com.gxwebsoft.shop.entity.OrderGoods;
import com.gxwebsoft.shop.param.OrderGoodsParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品信息控制器
 *
 * @author 科技小王子
 * @since 2024-05-26 15:42:03
 */
@Api(tags = "商品信息管理")
@RestController
@RequestMapping("/api/shop/order-goods")
public class OrderGoodsController extends BaseController {
    @Resource
    private OrderGoodsService orderGoodsService;

    @ApiOperation("分页查询商品信息")
    @GetMapping("/page")
    public ApiResult<PageResult<OrderGoods>> page(OrderGoodsParam param) {
        // 使用关联查询
        return success(orderGoodsService.pageRel(param));
    }

    @ApiOperation("查询全部商品信息")
    @GetMapping()
    public ApiResult<List<OrderGoods>> list(OrderGoodsParam param) {
        // 使用关联查询
        return success(orderGoodsService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:orderGoods:list')")
    @ApiOperation("根据id查询商品信息")
    @GetMapping("/{id}")
    public ApiResult<OrderGoods> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(orderGoodsService.getByIdRel(id));
    }

    @ApiOperation("添加商品信息")
    @PostMapping()
    public ApiResult<?> save(@RequestBody OrderGoods orderGoods) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
         orderGoods.setUserId(loginUser.getUserId());
        }
        if (orderGoodsService.save(orderGoods)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商品信息")
    @PutMapping()
    public ApiResult<?> update(@RequestBody OrderGoods orderGoods) {
        if (orderGoodsService.updateById(orderGoods)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商品信息")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (orderGoodsService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商品信息")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<OrderGoods> list) {
        if (orderGoodsService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商品信息")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<OrderGoods> batchParam) {
        if (batchParam.update(orderGoodsService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商品信息")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (orderGoodsService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
